'FFSubmenu=Effekte
'FFName=Transparenz

' ********************************************************************
' Transparenz.vbs (Skript fr FixFoto)
' Funktion:	Erstellung transparenter Bilder
'
' Copyright Harald Maeckler, Dsseldorf 2010 - 2015
' ********************************************************************
' Version 1.03 vom 14.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 1.02 vom 26.08.2015	- Bildschrfe verbessert
' Version 1.01 vom 17.08.2015	- Bug bei nicht gespeichertem Bild beseitigt
' Version 1.00 vom 01.04.2014	- Betaversion
' ********************************************************************

Option explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.03"
const SkriptURL = "http://www.ffsf.de/resources/transparenz.169/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'Allgemeine Variable
Dim Abbruch,Antwort
Dim WshShell,objFS

'Spezifische Konstanten und Variable
Dim Breite,Hoehe,VBild,VBreite,VHoehe
Dim FarbA,Farbe_RGB,TransA
const Min = 0,Max = 100					'Slidergrenzen
const RegSchluessel = "FF_Transparenz"	'Registerschlssel
'------------------------------------------------------------------------
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

call main

Set objFS = nothing
Set WshShell = nothing
'------------------------------------------------------------------------
Sub main	'### Hauptprogramm

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	Breite = FF_GetImageWidth	'Breite
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der" & vbNewLine &  "Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if Breite = 0 then										'Kontrolle ob ein Bild geladen ist
	msgbox "Kein Bild geladen!",vbCritical,"Abbruch"
	exit sub
end if
Hoehe = FF_GetImageHeight

'Vorschaubild
FF_PushImage
FF_Scale 400,400,true
VBreite = FF_GetImageWidth : VHoehe = FF_GetImageHeight
VBild = FF_GetScriptPath & "\VBild.jpg"
FF_PushImage

'** Start Dialog Transparenz **
FF_AddDialog "Transparenz",272,238
FF_AddControl "Transparenz","Farbe","STATIC",236,10,18,10
FF_SetControlStyle "Transparenz","Farbe",1
FF_AddControl "Transparenz","FarbA","COLOR",229,21,33,10
FF_AddControl "Transparenz","Transparenz","STATIC",229,46,33,10
FF_SetControlStyle "Transparenz","Transparenz",1
FF_AddControl "Transparenz","TransA","VSLIDER",240,59,18,151
FF_AddControl "Transparenz","Start","BUTTON",194,218,33,11
FF_AddControl "Transparenz","Abbruch","BUTTON",135,218,33,11
FF_AddControl "Transparenz","|","STATIC",217,94,12,10
FF_SetControlStyle "Transparenz","|",2
FF_AddControl "Transparenz","%","BUTTON",231,94,8,10
FF_AddControl "Transparenz","?","BUTTON",17,218,11,11
FF_AddControl "Transparenz","Update","BUTTON",57,218,33,11
'** End Dialog Transparenz **

FF_AddControl "Transparenz","V " & Skriptversion,"STATIC",31,218,24,11
FF_SetControlStyle "Transparenz","V " & Skriptversion,1

FF_AddControl "Transparenz","IMG","IMAGE",(200 - VBreite \2) \2 +10,(200 - VHoehe \2) \2 +10,VBreite \2,VHoehe \2

call RegistryLesen

do
	Abbruch = false
	FF_SetDialogTimer "Transparenz",20	 				'Dialogtimer setzen (20 ms)

	Select Case FF_ShowDialog ("Transparenz")
	Case "TIMER"
		FF_SetDialogTimer "Transparenz",0
		TransA = FF_GetControl ("Transparenz","TransA") 'Wert des Sliders abfragen,
		TransA = CInt(TransA * (Max - Min) / 255 + Min) '  anpassen an die Konstanten
		FF_SetControl "Transparenz","|", TransA 		'  und anzeigen
		
		'Transparenz erzeugen
		call Auswertung
		FF_SaveImage VBild,80
		FF_SetControl "Transparenz","IMG",VBild
	Case "FarbA"
		'Transparenz erzeugen
		call Auswertung
		FF_SaveImage VBild,80
		FF_SetControl "Transparenz","IMG",VBild
	Case "%"
		call Neuwert
		if TransA <> "" then
			FF_SetControl "Transparenz","|", TransA
			FF_SetControl "Transparenz","TransA", 255 - (CInt((TransA - Min) * 255 / (Max - Min))) '### Umkehrung durch 255 -
		end if
	Case "?"
		WshShell.Popup 	"Das Skript dient der Herstellung von Vorlagen fr Grukarten" & vbNewLine &_
						"und hnlichem." & vbNewLine & vbNewLine &_
						"Das Bild der Arbeitsflche wird mit einer transparenten Folie" & vbNewline &_
						"abgedeckt. Farbe und Transparenz der Folie sind einstellbar." & vbNewLine &_
						"Bei der minimalen Transparenz ist nur noch die Folie zu" & vbNewLine &_
						"sehen, bei maximaler Transparenz nur das Bild. Will man die" & vbNewLine &_
						"Transparenz als Zahl vorgeben, ist das nach Anklicken des" & vbNewLine &_
						"%-Zeichens mglich." &_
						"",,"Beschreibung",vbInformation
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Start"
		FF_PopImage
		call Auswertung
		FF_Reload
		exit do
	Case "CANCEL","Abbruch"
		exit do
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Transparenz")
if objFS.FileExists(VBild) then objFS.DeleteFile VBild,true

End sub
'------------------------------------------------------------------------
Sub Auswertung

FarbA		= FF_GetControl("Transparenz","FarbA")
Farbe_RGB	= Farbreferenz (FarbA)

FF_NewImage Breite,Hoehe,Farbe_RGB
FF_LogoMix "",100,0,0,TransA,0,0,false,0

End sub
'------------------------------------------------------------------------
Sub Neuwert
Dim W,m

'** Start Dialog Sollwert **
FF_AddDialog "Sollwert",48,48
FF_AddControl "Sollwert","NWert","SLEDIT",16,17,18,9
FF_SetControlStyle "Sollwert","NWert",8193
FF_AddControl "Sollwert","OK","BUTTON",16,31,18,11
'** End Dialog Sollwert **

m = "von " & min & " bis " & max
FF_AddControl "Sollwert",m,"STATIC",4,4,40,10
FF_SetControlStyle "Sollwert",m,1

FF_ActivateControl "Sollwert","NWert"

do
	Select Case FF_ShowDialog ("Sollwert")
		Case "+/-"
			W = FF_GetControl("Sollwert","NWert")
			if IsNumeric(W) then
				W = W * -1
				if W >= Min and W <= Max then
					FF_SetControl "Sollwert","NWert",W
				else
					msgbox "Der eingetragene Wert mu >= " & Min & " und <= " & Max & " sein!",vbExclamation,"Hinweis"
				end if
			end if
		Case "OK"
			W = FF_GetControl("Sollwert","NWert")
			if IsNumeric(W) then
				W = W * 1
				if W >= Min and W <= Max then
					TransA = W
					exit do
				else
					msgbox "Der eingetragene Wert mu >= " & Min & " und <= " & Max & " sein!",vbExclamation,"Hinweis"
				end if
			end if
		Case "CANCEL"
			exit do
	End Select
loop

FF_CloseDialog ("Sollwert")

End Sub
'--------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen
FarbA = FF_GetProfile (RegSchluessel,"FarbA")
if len(FarbA) = 0 then FarbA = "255 255 255"

TransA = FF_GetProfile (RegSchluessel,"TransA")
if len(TransA) = 0 then TransA = 50


'### Werte eintragen
FF_SetControl "Transparenz","FarbA",FarbA
FF_SetControl "Transparenz","TransA",TransA

End sub
'--------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen
FarbA = FF_GetControl("Transparenz","FarbA")
TransA = FF_GetControl("Transparenz","TransA")

'Werte schreiben
FF_WriteProfile RegSchluessel,"FarbA",FarbA
FF_WriteProfile RegSchluessel,"TransA",TransA

End sub
'--------------------------------------------------------------------------
'************************************************************************
'Funktion Farbreferenz
'************************************************************************
Function Farbreferenz (RGB_Wert)
'RGB-Wert ("000 000 000" bis "255 255 255") zu Farbreferenz (0 - 16777215)
Dim C_Array
	C_Array = split(RGB_Wert," ")
	Farbreferenz = C_Array(0) + C_Array(1) * (2^8) + C_Array(2) * (2^16)
End Function
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
